/*!
 *************************************************************************
 *	TvOg番䃌WX^̒lvZ.
 *************************************************************************
int	freq_cal(double uSec,int *pADST0val,double *pErr);
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "config.h"
#include "window.h"
#include "dllcall.h"

#include "sampling.h"

#define	DEBUG_PRINT	1

/*!
 *************************************************************************
 *	TvOg番䃌WX^̒lvZ.
 *************************************************************************
 *	in:		uSec   		\ 1div ̎( microSec )
 *	out:	pADST0val	ADST0 WX^ɐݒ肷l. (M<<8) | N ŕԂ.
 *			pErr		pADST0val̗pꍇA_lƂ̌덷.iԎXP[␳j
 *************************************************************************
 *	TvO = (1/HCLK) * ( (N+1) * M + 3 )			iNADSTSTl,MSTXlj
 *	RyA     = (1/HCLK) * ADCT(1`65) * 14   	iAARyAԂ50nsȏ2000nsȉj
 *	TvO = TvO { RyA
 *************************************************************************
 *	ȏ̎tZ
 *	䃌WX^ M,N ̍œKloAɂċ܂
 *	ŗ^ꂽƂ̌덷err Ԃ.
 *
 *	ADST0ɐݒ肷l M(ׂ̂\) ƁA N (4`31)
 *:
 *	TvO̒̕l(M=3,N=15 ɂ 1:259,ł1.8ʕbx)
 *	菬ƁA荞݉ԂɍȂȂnOAbvǏɂȂ̂Œ.


//	|x ( ʕb / division )
static	int sweep_table[10]={
//    50,
   100,
   200,
   500,
  1000,
  2000,
  5000,
 10000,
 20000,
 50000,
};
//	500kSps
	int Tad=20-(12+1);	// [1..31]
	int ADCs=2+1;		// [1..256]
//	500kSps
	int Tad=(rate>>8) & 0x1f;	// [1..31]
	int ADCs=(rate)   & 0xff;	// [1..256]
 */
#define	HCLK	20.0	// (MHz)

int	freq_cal(double uSec,int *pADST0val,double *pErr)
{
	double dpl = (double)SCOPE_RECT_W / (double)XDIV;	// 1 div   ʕ\ dot 𓾂. ( 16 )
				//  			776.0 / 16.0
	double dp  = uSec / dpl;	// Ԏ𑜓x : PhbgmicroSec
	double div = dp * HCLK;		// ̑f. 20MHz vZ.
	double d;					//
	double err=1.0;				// 덷.

	// Tad=s 7 Œ. == A/D Ŝ20Clock.
	int Tad=20-(12+1);	// [1..31]

	// ADCs NbNx[XvZŋ߂.
	int ADCs=2;			// [1..256]
	// A/D ϊTCN(S)= (100nS * 20 * ADCs)

//	ADCsςĂ݂.
	ADCs = (div / 20.0);
//
	if(ADCs < 2)    ADCs=2;
	if(ADCs >= 256) ADCs=256;
	//
	//	䃌WX^ւ̐ݒl.
	//
	*pADST0val = (Tad<<8) | (ADCs-1) ;
	//
	//	ǐœoj
	//
	double rate = ADCs * 20;

	//	iׂj 
	double real = div;
	err = rate / real;	//덷(g`\̍ۂɊg␳ׂ搔)
	*pErr = err;

	*pErr = err;

#if	DEBUG_PRINT	
	//	uSec: Pڐ(傫ڐ)̎(ʕb)
	//	ADCs: A/Dϊx[XNbN.[1..256]
	//	err	: 덷(gkőΉ̂ŁA\g嗦ƂĎgp)
	//	real: ^̕
	//	rate: s̕
	//	sps	: TvO/b.
	//
	printf("freq_cal(%g uSec/div) ADCs=%d err=%g real=%g(Count/Clock) rate=%f sps=%f(Samples/Sec)\n"
			,uSec,ADCs,err,real,rate,20000000.0/rate);
#endif

	return *pADST0val;
}



#if	0
#define	HCLK	144.0
#define	CompTime	10					//RyAԂ߂ADCT̒l.
#define	OVERHEAD	(1+14*(CompTime+2))	//RyAԂ̃NbN.+2Ă̂ADCTl+2ɂȂ邽.
int	freq_cal(double uSec,int *pADST0val,double *pErr)
{
	double dpl = (double)SCOPE_RECT_W / (double)XDIV;	// 1 div   ʕ\ dot 𓾂. ( 16 )
				//  			776.0 / 16.0
	double dp  = uSec / dpl;	// Ԏ𑜓x : PhbgmicroSec
	double div = dp * HCLK;		// ̑f. 144MHz vZ.
	double d;					//
	double err;					// 덷.

	//
	//	䃌WX^ M,N yA̒lsIɌ߂.
	//

	int i=3;	// i: 3, 4, 5,  6,  7	: im͘AĂ.
	int m,n;	// m:16,32,64,128,256	.
	for(m=16;m<256;m*=2,i++) {		//  m = 16,32,64,128,256̏Ɏ.
		d = ( div - OVERHEAD ) / m - 1;	// d = ( TvOg / m ) - 1
		if( ( d >= 4.0 ) && (d < 31.0 ) ) {	// d 肤l 4 ` 31
			break;
		}
		if( (i==3) && (d < 4.0) ) {
			break;					// Tvg.
		}
	}
	n = (int) d;					// d  n ɓǂݑւ.
	
	if(n>31) {n = 31;}
	if(i==3) {						// i=3(m=16)̂Ƃ n>=12łȂƃnOAbvĂ܂.
		if(n<12) {n = 12;}
//		if(n<24) {n = 24;}
	}
	//
	//	䃌WX^ M,N yA̒l  8bit(N)Ɖ8bit(Nindexl3`7)ɕĕԂ.
	//
	*pADST0val = (n<<8) | i ;			//ADC SampTimeN0 , SampTime
	//
	//	ǐœoj (N+1) * M + 1
	//
	double rate = (n+1) * m + OVERHEAD;

	//	iׂj 
	double real = div;
	err = rate / real;	//덷(g`\̍ۂɊg␳ׂ搔)
	*pErr = err;

#if	DEBUG_PRINT	
	//	uSec: Pڐ(傫ڐ)̎(ʕb)
	//	N	: 䃌WX^N (ADST ST)
	//	M   : 䃌WX^M (ADST STX)
	//	err	: 덷(gkőΉ̂ŁA\g嗦ƂĎgp)
	//	real: ^̕
	//	rate: s̕
	//	sps	: TvO/b.
	//
	printf("freq_cal(%g) N=%d,M=%d err=%g real=%g rate=%g sps=%g\n",uSec,n,i,err,real,rate,144000000.0/rate);
#endif

	return *pADST0val;
}
#endif

/*!
 *************************************************************************
 *
 *************************************************************************
 */
void freq_test()
{
	static	int	us[]={
		100,200,500,1000,2000,5000,10000,20000,50000,0
	};
	int i,adst0;
	double err;
	for(i=0;us[i];i++) {
		freq_cal(us[i],&adst0,&err);
		printf("%6d,%02x,%10g\n",us[i],adst0,err);
	}

}
/*!
 *************************************************************************
 *
 *************************************************************************
 */

