#ifndef	_sampling_h
#define	_sampling_h

#include "utype.h"

//! 	TvOp[^\.
typedef struct {
// 	--------------------------------------------------
	uchar  cmd;			//!< +00				SAMPLING
	uchar  subcmd;		//!< +01 = a/d;		a=1 d=2 stop=0
	ushort size;		//!< +02 = count;		1040
	uint   rate;		//!< +04 = rate;		1000(sample/sec)
// 	--------------------------------------------------
	ushort channels;	//!< +08	ch(s)  = channels(1..16) 1(chs)
	uchar  port_sel;	//!< +0a				0(port)
	uchar  reserve[5];	//!< +0b
// 	--------------------------------------------------
} SAMPLE_PARAM;			//!<  16bytes

//! 	Tv^[wb_[.
typedef struct {
// 	--------------------------------------------------
	uchar  cmd;			//!< +00				SAMPLING
	uchar  subcmd;		//!< +01 = a/d;		a=1 d=2 stop=0
	ushort size;		//!< +02 = count;		1040
	uint   rate;		//!< +04 = rate;		1000(sample/sec)
// 	--------------------------------------------------
	uchar  reserve[3];	//!< +08
	uchar  overrun;		//!< +0b
	uint   debug_cnt;	//!< +0c
// 	--------------------------------------------------
} SAMPLE_RETURN;			//!<  16bytes

//! 	SAMPLE_PARAMsubcmdtB[h̒l.
enum {
	ADC_STOP,
	ADC_ANALOG,
	ADC_DIGITAL,
};

//! 	Xbhԃf[^󂯓n̂߂̍\.
typedef struct {
// 	--------------------------------------------------
	int		cmd;		//!<  0=idle 1=read 2=stop
	int		ret;		//!<  thread_cmd ̃^[.

	SAMPLE_PARAM param;

// 	--------------------------------------------------
} THREAD_PARAM;

//! 	THREAD_PARAMthread_cmdtB[h̒l.
enum {
	THREAD_IDLE,	//!<  AChO.
	THREAD_READ,	//!<  TvOǂݍݒ.
	THREAD_PAUSE,	//!<  |[Y.
	THREAD_OVERRUN,	//!<  I[o[ɂ~.
	THREAD_START,	//!<  XbhN.
	THREAD_EXIT,	//!<  XbhI.
};

//! 	Windows̊֐.
int	 InitSample();
int  StartSample(SAMPLE_PARAM *param);	//!< TvOJn.
int  StopSample();						//!< TvO~.
int	 ReadSample(ushort *buf,int size,int nowait);	//!< TvOf[^ǂݎ.
void StopThread();

#endif
