/*!
 *************************************************************************
 *	CDCLink DLL ̌Ăяo.
 *************************************************************************
	int LoadDLL(char *dllname);		//	DLLǂݍ݂Ə.
	int	UnloadDLL();				//  DLLJ.
 */

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "config.h"
#include "dllcall.h"

#include "sampling.h"
#include "fifo.h"

#define		VERBOSE_DEBUG	0

extern	int		device_id;


/*!
 *************************************************************************
 *
 *************************************************************************
 */

HINSTANCE hDLL = NULL;		// cdclink.dll handle

/*!
 *************************************************************************
 *         cdclink.dll [h
 *************************************************************************
 */
int LoadDLL(char *dllname)
{
	//
	//	piclink.dllǂݍ.
	//
	hDLL = LoadLibrary(dllname);
	if (!hDLL) {
#if 0
		fprintf(stderr, "Error at Load '%s'\n",dllname);
#else
		MessageBox(NULL, "Error at Load DLL", "ERR", MB_OK);
#endif
		return -1;
	}

	//
	// import֐ꂼ̊֐|C^pӂāAimportɃ|C^Zbg.
	//
	openDevice  = (_openDevice )GetProcAddress(hDLL, "openDevice");  
	closeDevice = (_closeDevice)GetProcAddress(hDLL, "closeDevice"); 
	sendCommand = (_sendCommand)GetProcAddress(hDLL, "sendCommand"); 	
#if	VERBOSE_DEBUG
	printf("openDevice()=%x\n"	,(int) openDevice );
	printf("closeDevice()=%x\n"	,(int) closeDevice );
	printf("sendCommand()=%x\n"	,(int) sendCommand );
#endif
	if( InitSample() < 0 ) {
#if 0
		fprintf(stderr, "Error at InitSample '%s'\n",dllname);
#else
		MessageBox(NULL, "Error at InitSample", "ERR", MB_OK);
#endif
		UnloadDLL();
		return -1;
	}
	return 0;
}


/*!
 *************************************************************************
 *         cdclink.dll J
 *************************************************************************
 */
int UnloadDLL(void)
{
	if( hDLL ) {
		//
		//	XbhgpȂ~.
		//
		StopThread();
		//
		//	foCXgpȂ~.
		//
		if(	device_id ) {
			closeDevice();
			device_id=0;
		}
		//
		//	DLLJ.
		//
		FreeLibrary(hDLL);
		hDLL = 0;
	}
	return 0;
}

