/*!
 *************************************************************************
 *	SamplinǧĂяo.
 *************************************************************************
 *
	int StartSample(SAMPLE_PARAM *param);	//TvOJn.
	int StopSample();						//TvO~.

// StartSample(param)sȂƁAǂݍݐp̃XbhFIFOɓǂݍݑ.
// ReadSample(buf,size)ɂāAf[^.

	int	ReadSample(ushort *buf,int size,int nowait);	//TvOf[^ǂݎ.

// ŐṼf[^sizeoCg擾. 擾oCgԂ.
// nowait=1̂ƂsizeoCgɖȂꍇłƂ肠擾đ^[.

ӓ_:
	// ReadSamplesȂĂÃf[^Âłۏ؂͂Ȃ.
	// iReadSampleĂяoꂽ_ł̍ŐVf[^󂯎Ƃj
	// Ȃ̂ŁAPʕ̃f[^͈xɎ擾悤ɂ.
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "config.h"
#include "window.h"
#include "dllcall.h"

#include "sampling.h"
#include "fifo.h"

#define		DEBUG			0
#define		FIFO_SIZE		0x400000	// 4MB

//	Xbhԃf[^󂯓n̂߂̍\.
static	THREAD_PARAM s_param;
static	HANDLE  s_thread ;		// Read Xbh̃nh.
static	DWORD   s_thid;

static	FIFO 	s_fifo_queue;
static	FIFO   *queue = &s_fifo_queue;
static	u_char *s_fifo_buf;

#define	PACKET_SIZE		64			// USBR}hPpPbgbyte size
#define	RBUF_SIZE		(1024)		// 1̃TvOf[^擾byte size


extern	int		device_id;
		int		g_debug_count;
/*!
 *************************************************************************
 *
 *************************************************************************
 */
void memdump(char *msg, char *buf, int len)
{
	int j;
	fprintf(stderr, "%s", msg);
	for (j = 0; j < len; j++) {
		fprintf(stderr, " %02x", buf[j] & 0xff);
		if((j & 0xf)==  7)
			fprintf(stderr, " ");

		if((j & 0xf)== 15)
			fprintf(stderr, "\n +");
	}
	fprintf(stderr, "\n");
}


/*!
 *************************************************************************
 *
 *************************************************************************
 */
int StartSample(SAMPLE_PARAM *param)
{
	if(device_id==0) return -1;
#if	DEBUG
	printf("StartSample()\n");
#endif
	THREAD_PARAM *p = &s_param;
	p->param = *param;
	p->cmd = THREAD_START;

#if	1
	printf("StartSample() size = %d ADST0=%02x chs=%04x\n"
		,s_param.param.size
		,s_param.param.rate
		,s_param.param.channels
	);
#endif
	return 0;
}
/*!
 *************************************************************************
 *
 *************************************************************************
 */
int	StopSample(void)
{
	if(device_id==0) return -1;
#if	DEBUG
	printf("StopSample()\n");
#endif
	THREAD_PARAM *p = &s_param;
	p->cmd = THREAD_PAUSE;
	return 0;
}

/*!
 *************************************************************************
 *	TvOf[^ǂݎ.
 *************************************************************************
 */
int	ReadSample(ushort *buf,int size,int nowait)
{
	int retry=0;
	int qsize;

	for(retry=0;retry<3;retry++) {
		qsize = FIFO_getnewdata(queue,(u_char*)buf,size*sizeof(short));	//L[o.
#if	DEBUG
		printf("ReadSample()=%d/%d\n",qsize,size);
#endif
		if( qsize >= size ) break;
		Sleep(1);
	}

	return qsize;
}

/*!
 *************************************************************************
 *			Xbh~
 *************************************************************************
 */
void StopThread()
{
	if(	s_thread ) {
		s_param.cmd=THREAD_EXIT;
		Sleep(100);
#if	DEBUG
		DWORD exitCode=0;
		if( GetExitCodeThread(s_thread,&exitCode) == 0 ) {
			printf("GetExitCodeThread() Error!\n");
		}else{
			printf("GetExitCodeThread()=%ld\n",exitCode);
		}
#endif
		s_thread = 0;
	}

}

/*!
 *************************************************************************
			TvOJn  f[^擾.
 *************************************************************************
 */
static	int	sample_start(SAMPLE_PARAM *param,uchar *buf,int size)
{
	uchar cmdbuf[64];

	memcpy(cmdbuf,param,sizeof(SAMPLE_PARAM));

//	cmdbuf[4]=20;		//ADCs
//	cmdbuf[5]=7;		//Tad (20-13)
	if(cmdbuf[4]<2) cmdbuf[4]=2;
	if(cmdbuf[5]<3) cmdbuf[5]=3;

	sendCommand(cmdbuf,PACKET_SIZE,buf,size);
	return 0;
}

/*!
 *************************************************************************
			TvO~.
 *************************************************************************
 */
static	int	sample_stop()
{
	SAMPLE_PARAM buf;
	memset(&buf,0,sizeof(buf));
	sample_start(&buf,NULL,0);
	return 0;
}

/*!
 *************************************************************************
 *	FIFOɗD挠tŃf[^𗭂߂.
 *************************************************************************
 */
void FIFO_enqueue_prior(FIFO *queue,uchar *buf,int size)
{
	//
	//	FIFŐ󂫂ȂƂ́A󂯂.
	//
	int fre = FIFO_getfreesize(queue);
	if(	fre < size ) {
		FIFO_drop(queue,align_size(size,16 * sizeof(short) ));
	}
	//
	//	FIFOɂ߂.
	//
	FIFO_enqueue(queue,buf,size);
}

/*!
 *************************************************************************
 *
 *************************************************************************
 */
int	channels2ch(int channels)
{
	if(channels == 0x0001) return 1;
	if(channels == 0x0003) return 2;
	if(channels == 0x000f) return 4;
	if(channels == 0x00ff) return 8;
	if(channels == 0xffff) return 16;
	return 1;
}
/*!
 *************************************************************************
 *
 *************************************************************************
 */
int	chadd(int ch,int add,int chmax)
{
	ch+=add;
	if(ch>=chmax) ch=0;
	return ch;
}
/*!
 *************************************************************************
 *	f[^tH[}bgϊ. 30bit --> short
 *************************************************************************
 *	size 64z.	ϊ̃Tv͍őŁA16*3=48Tv.
 */
int	Convert_30bit_to_short_Sub(ushort *sample,uchar *buf,int size,int ch)
{
	int i,total=0;
	int a0,a1,a2,c;
	uint *s=(uint *)buf;
	int chan=0;
	int add=0;

	if(ch>1) {
		add=1;
	}

	size >>=2;
	for(i=0;i<size;i++) {
		c = *s++;if(c==0) break;
		a0=       c & 0x3ff;
		a1= (c>>10) & 0x3ff;
		a2= (c>>20) & 0x3ff;
		sample[0] = (a0 << 6)|chan;chan=chadd(chan,add,ch);	// 10biťʂ16bitlɂ.
		sample[1] = (a1 << 6)|chan;chan=chadd(chan,add,ch);
		sample[2] = (a2 << 6)|chan;chan=chadd(chan,add,ch);
		sample+=3;
		total +=3;
	}
	return total;
}
/*!
 *************************************************************************
 *	f[^tH[}bgϊ. 30bit --> short
 *************************************************************************
 *	size 1024z.
 */
int	Convert_30bit_to_short(ushort *sample,uchar *buf,int size,int ch)
{
	int i,rc,total=0;
	for(i=0;i<size;i+=64) {
		rc = Convert_30bit_to_short_Sub(sample,buf,64,ch);
		buf    += 64;
		sample += rc;
		total  += rc;
	}
	return total;
}

/*!
 *************************************************************************
 *	FIFOɃf[^tH[}bgϊȂ~ς.
 *************************************************************************
 */
void EnqueueSample(FIFO *queue,uchar *buf,int size,int channels)
{
	ushort sample[2048];
	int    samples;
	int	   ch = channels2ch(channels);
	samples = Convert_30bit_to_short(sample,buf,size,ch);
	FIFO_enqueue_prior(queue,(uchar*)sample,samples*2);	//L[ɂ߂.
}
/*!
 *************************************************************************
 *	USB READ Xbh
 *************************************************************************
 */
DWORD WINAPI read_thread(LPVOID param)
{
	THREAD_PARAM *p = &s_param;
	uchar rbuf[RBUF_SIZE];
	int size = RBUF_SIZE;
	int getsize;


	while(1) {
		if(p->cmd == THREAD_EXIT) {
			sample_stop();
			Sleep(30);
			break;
		}
		switch(p->cmd) {
		 case THREAD_IDLE:
			Sleep(1);
			break;
		 case THREAD_OVERRUN:
			Sleep(1);
			break;
		 case THREAD_START:
			FIFO_init( queue , s_fifo_buf , FIFO_SIZE);
			p->cmd=THREAD_READ;
			break;
		 case THREAD_READ:
			sample_start(&p->param,rbuf,size);
			getsize = size;
#if	0
			result=(SAMPLE_RETURN *)rbuf;
			if(result->overrun == 1) {	//Overrun!
				FIFO_reset( queue );
			}
			g_debug_count = result->debug_cnt;
#endif

			SAMPLE_PARAM *s = &s_param.param;
//			FIFO_enqueue_prior(queue,rbuf,getsize);	//L[ɂ߂.
			EnqueueSample(queue,rbuf,getsize,s->channels);
			break;

		 case THREAD_PAUSE:
			sample_stop();
		 	p->cmd = THREAD_IDLE;
			break;
		}
	}
	ExitThread(99);
	return 0;
}


/*!
 *************************************************************************
 *
 *************************************************************************
 */

int	InitSample()
{
	//
	//	FIFȌ.
	//
	s_fifo_buf = malloc(FIFO_SIZE);
	FIFO_init( queue , s_fifo_buf , FIFO_SIZE);

	if(	device_id==0) {
		int rc= openDevice(0,NULL);
		if(	rc!=0 ) return rc;		//G[.
		device_id = 1;	// OK.
#if	DEBUG
		printf("device_id = %x\n",device_id);
#endif
	}
	//
	//	USB READ XbhN.
	//
	s_thread = CreateThread(NULL, 0, read_thread, NULL, 0, &s_thid);
	return 0;	//OK.
}
/*!
 *************************************************************************
 *
 *************************************************************************
 */

